#!/usr/bin/env bash
if [ "$BASH_VERSION" = "" ]; then bash $0; fi
if [ "$UID" != "0" ]; then echo -e "\n############\n# not root #\n############\n";exit 1; fi
if [ -z "$1" ]; then echo -e "\n########################################################\n# no installation medium given, e.g. ./$0 /dev/sdb #\n########################################################\n";exit 1; fi
bash reset.sh
DRIVE="$1"
FAILED=0
clear
cat .external/.motd1

echo -e "\n    ***************************************************************************************"
echo -e "    ***************************************************************************************"
echo -e "    * system packages: 'build-essential' and 'texinfo' are mandatory to this installation *"
echo -e "    ***************************************************************************************"
echo -e "    ***************************************************************************************"
sleep 3

echo -e "\n##########################"
echo 'checking for prerequisites'
echo -e "##########################"

sleep 1

exist () { THIS=$(which $1); if [ $? -eq 1 ]; then echo -n "FAIL >$THIS $1 not installed: install like "; if ! [ -z "$2" ]; then echo "$2"; else echo "pacman -Sy $1, emerge $1, apt install $1, brew install $1"; fi; FAILED=1; else echo "PASS > $THIS exists"; fi }
check () { THIS=$(bash -c "$1"); if [ $? -eq 1 ]; then echo "FAIL >$THIS $1 not installed: install like pacman -Sy $1, emerge $1, apt install $1, brew install $1"; FAILED=1; else echo "PASS > $THIS checks"; fi }

exist "bison"
exist "gawk"
exist "git"
exist "htop"
exist "tmux"
exist "python3"
check "python3 -m pip --version"
exist "virtualenv" "python3 -m pip install virtualenv"

if [ $FAILED -eq 1 ]; then echo "##############################################################################";echo "pre-requisites not installed, fix these before running this installation again";echo "##############################################################################";exit 1; fi

echo -e "\n###########################################"
echo "pre-requisites met, continuing installation"
echo -e "###########################################"

virtualenv .env -p python3
. .env/bin/activate
python3 -m pip install -r .external/requirements.txt
deactivate

tmux new-session -d -s dr1pt
tmux send-keys -t dr1pt "source .env/bin/activate" Enter
tmux send-keys -t dr1pt "cat .external/.motd2" Enter
tmux send-keys -t dr1pt "python3 .external/decoded/dr1pt.py $DRIVE" Enter
tmux attach -t dr1pt
